
%global PREFIX /usr/
%global BINDIR %{PREFIX}/bin
%global DOMAIN github.com
%global ORG kata-containers
%global PROJECT runtime
%global IMPORTNAME %{DOMAIN}/%{ORG}/%{PROJECT}

%if %{?oraclelinux} == 7
%global DEFAULT_QEMU /usr/bin/qemu-system-x86_64
%else
%global DEFAULT_QEMU /usr/libexec/qemu-kvm
%endif

%if 0%{?suse_version}
%define LIBEXECDIR %{_libdir}
%else
%define LIBEXECDIR %{_libexecdir}
%endif

%undefine _missing_build_ids_terminate_build
%define  debug_package %{nil}
%global golang_version 1.16
%global _buildhost build-ol%{?oraclelinux}-%{?_arch}.oracle.com

Name:      kata-runtime
Version:   1.12.1
Release:   8%{?dist}
Source0:   %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:    Oracle America
Summary:   Kata containers OCI compatible runtime
Group:     Development/Tools
License:   Apache-2.0

BuildRequires: git
BuildRequires: golang >= %{golang_version}
%if 0%{?suse_version} && 0%{?is_opensuse}
BuildRequires: openSUSE-release
%endif
BuildRequires: libselinux-devel

Requires: kata-proxy >= 1.12.1
Requires: kata-shim >= 1.12.1
Requires: kata-ksm-throttler >= 1.12.1
%if %{?oraclelinux} == 7
Requires: qemu >= 2:2.9.0-9
%endif
%if %{?oraclelinux} == 8
Requires: qemu-kvm >= 2:2.9.0-9
%endif
%if %{?oraclelinux} == 9
Requires: qemu-kvm
%endif
Requires: kernel-uek-container >= 4.14.14-4
Requires: kata-image >= 1.12.1

%description
Kata Containers runtime component leverages the virtcontainers package to provide a high-performance standards-compliant runtime that creates hardware-virtualized containers. The runtime is OCI-compatible, CRI-O-compatible, and Containerd-compatible, allowing it to work seamlessly with both Docker and Kubernetes respectively.

%prep
%setup 

%build
export GO111MODULE=auto
export GOPATH=$HOME/rpmbuild/BUILD/go/

mkdir -p $HOME/rpmbuild/BUILD/go/src/%{DOMAIN}/%{ORG}
ln -s %{_builddir}/kata-runtime-%{version} $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
cd $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
make \
	QEMUPATH=%{DEFAULT_QEMU} \
	FEATURE_SELINUX=yes

%install
export GOPATH=$HOME/rpmbuild/BUILD/go/

cd $HOME/rpmbuild/BUILD/go/src/%{IMPORTNAME}
make \
    PREFIX=/usr/ \
    DESTDIR=%{buildroot} \
    QEMUPATH=%{DEFAULT_QEMU} \
    SKIP_GO_VERSION_CHECK=1 \
    install
sed -i -e '/^initrd =/d' %{buildroot}/usr/share/defaults/kata-containers/configuration.toml

%files
%license LICENSE THIRD_PARTY_LICENSES.txt NOTICE
%defattr(-,root,root,-)
/usr/bin/kata-runtime
/usr/bin/kata-collect-data.sh
/usr/bin/containerd-shim-kata-v2
/usr/share/defaults/kata-containers/configuration.toml
/usr/share/defaults/kata-containers/configuration-qemu.toml
/usr/share/defaults/kata-containers/configuration-fc.toml
%ifnarch %{arm} arm64 aarch64
/usr/share/defaults/kata-containers/configuration-acrn.toml
/usr/share/defaults/kata-containers/configuration-clh.toml
/usr/share/defaults/kata-containers/configuration-qemu-virtiofs.toml
%endif
/usr/share/bash-completion/completions/kata-runtime
/usr/libexec/kata-containers/kata-netmon

%changelog
* Thu Aug 24 2023 Murali Annamneni <murali.annamneni@oracle.com> - 1.12.1-8
- Bump release inline with other kata packages for fixing timestamp issue

* Thu Aug 03 2023  Murali Annamneni <murali.annamneni@oracle.com> - 1.12.1-7
- Add support for ARM build

* Wed May 31 2023  Michael Thompson <michael.a.thompson@oracle.com> - 1.12.1-6
- Add OL9 support

* Wed Mar 22 2023 Guoyong Zhang <guoyong.zhang@oracle.com> - 1.12.1-5
- Updated qemu-kvm machine options to work with more versions of kvm_utils

* Mon Apr 25 2022 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-4
- Updated THIRD_PARTY_LICENSES.txt generated using pls attribution-helper

* Mon Nov 22 2021 Durai Govindasamy <durai.vattakalvalasu.govindas@oracle.com> - 1.12.1-3
- updated golang version
- added buildhost variable

* Tue Mar 23 2021 Thomas Tanaka <thomas.tanaka@oracle.com> - 1.12.1-2
- Golang 1.15.9

* Fri Jan 15 2021 Olcne-Builder Jenkins <olcne-builder_us@oracle.com> - 1.12.1-1
- Added Oracle Specific Files For kata-runtime
